﻿using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Shared.Events;
using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    private DataTable GetColumn3DData()
    {
        DataTable mydata = new DataTable();
        //Define the columns and their names
        mydata.Columns.Add("Series Labels", typeof(string));
        mydata.Columns.Add("Column A", typeof(int));
        mydata.Columns.Add("Column B", typeof(int));
        mydata.Columns.Add("Column C", typeof(int));
        //mydata.Columns.Add("Column D", typeof(int));
        //Add the rows of data
        mydata.Rows.Add(new Object[] { "Series A", 10, 40, 100});
        //mydata.Rows.Add(new Object[] { "Series B", 3, 6, 4, 5 });
        //mydata.Rows.Add(new Object[] { "Series C", 5, 8, 6, 7 });
        //mydata.Rows.Add(new Object[] { "Series D", 7, 10, 7, 7 });
        return mydata;
    }

    List<Text> TextList = new List<Text>();

    protected void Page_Load(object sender, EventArgs e)
    {
        this.UltraChart1.DataSource = GetColumn3DData();
        this.UltraChart1.DataBind();

        this.UltraChart1.FillSceneGraph += new FillSceneGraphEventHandler(UltraChart1_FillSceneGraph);
    }
   


    public class MyObject
    {
        private int intValue2;

        public int IntValue2
        {
            get { return intValue2; }
            set { intValue2 = value; }
        }

        private int intValue;

        public int IntValue
        {
            get { return intValue; }
            set { intValue = value; }
        }

        private Primitive textPrimitive;

        public Primitive TextPrimitive
        {
            get { return textPrimitive; }
            set { textPrimitive = value; }
        }

        private string textValue;

        public string TextValue
        {
            get { return textValue; }
            set { textValue = value; }
        }
    }



    protected void UltraChart1_FillSceneGraph(object sender, FillSceneGraphEventArgs e)
    {
        TextList.Clear();

        
        List<MyObject> list = new List<MyObject>();

        foreach (Primitive pr in e.SceneGraph)
        {


            if (pr.Row != -1 && pr.Column != -1)
            {
                float xMax = ((Infragistics.UltraChart.Core.Primitives.Path)(pr)).GraphicsPath.PathPoints.Max(p => p.X);
                float xMin = ((Infragistics.UltraChart.Core.Primitives.Path)(pr)).GraphicsPath.PathPoints.Min(p => p.X);

                float yMax = ((Infragistics.UltraChart.Core.Primitives.Path)(pr)).GraphicsPath.PathPoints.Max(p => p.Y);
                float yMin = ((Infragistics.UltraChart.Core.Primitives.Path)(pr)).GraphicsPath.PathPoints.Min(p => p.Y);

                string temp = pr.Value.ToString();

                int x = Convert.ToInt32((xMax + xMin) / 2);
                int y = Convert.ToInt32((yMax + yMin) / 2);



                Text textLable = new Text(new Point(x, y), temp);
                textLable.PE.Fill = Color.Black;

                MyObject obj = new MyObject();
                obj.IntValue = y;
                obj.IntValue2 = x;
                obj.TextPrimitive = textLable;
                obj.TextValue = pr.Value.ToString();

                list.Add(obj);
                TextList.Add(textLable);
            }
        }


        foreach (Text item in TextList.Distinct())
        {
            int iii = list.Where(p => p.TextValue == item.GetTextString()).Min(s => s.IntValue);
            int iii2 = list.Where(p => p.TextValue == item.GetTextString()).Min(s => s.IntValue2);
            MyObject obj = list.Where(s => s.IntValue == iii).First() as MyObject;
            if (obj != null) e.SceneGraph.Add(obj.TextPrimitive);
        }
    }
}
